#include <p18F4620.inc>

;----- Background debug register addresses ------------------------------------
DEBUG			equ	0xFD4
ICKBUG			equ	0xFB9
BIGBUG			equ	0xFB8
GLOBUG			equ	0xFB7
SLGBUG			equ	0xFB5

;----- DEBUG register BITS ----------------------------------------------------
INBUG			equ	7
FREEZ			equ	6
SSTEP			equ	5
SHDW			equ	4
BRB7			equ	3
BRB6			equ	2
BTRIS7			equ	1
BTRIS6			equ	0


#define	bank_num	.1


#define bank_up		bank_num*0x0100

	cblock	bank_up
	BSR_TEMP	
	bdm_counter
	bdm_register
	STAT_T
	W_TEMP
	FS0L_T
 	FS0H_T
 	PCLH_T 
 	PCLU_T 
	TBLPTRL_T
	TBLPTRH_T
	endc

	#define	LEDR	LATC,0
	#define	LEDY	LATC,2

	org	0x0000
	movff 	BSR, BSR_TEMP
	movlb 	bank_num
	MOVFF 	STATUS,STAT_T
	MOVWF 	W_TEMP
	MOVFF 	FSR0L,FS0L_T
	MOVFF 	FSR0H,FS0H_T
	MOVFF 	PCLATH,PCLH_T 
	MOVFF 	PCLATU,PCLU_T 
	movff	TBLPTRH,TBLPTRH_T
	movff	TBLPTRL,TBLPTRL_T

	bsf		DEBUG, SHDW
	bsf		DEBUG,BTRIS6
	bcf		DEBUG,BTRIS7
	bsf		DEBUG,BRB7
	bcf		DEBUG,SSTEP

	tstfsz	STKPTR
	bra		bdm_disp
	incf	STKPTR
	clrf	TOSL
	clrf	TOSH
	clrf	TOSU

bdm_disp
;	bcf		DEBUG,BTRIS7
;	bsf		DEBUG,BRB7
	rcall	bdm_receive
	movlw	0x01
	cpfseq	bdm_register,BANKED
	bra		s1
	bra		r1
s1
	movlw	0x02
	cpfseq	bdm_register,BANKED
	bra		s2
	bra		r2
s2
	movlw	0x03
	cpfseq	bdm_register,BANKED
	bra		s3
	bra		r3
s3
	movlw	0x04
	cpfseq	bdm_register,BANKED
	bra		s4
	bra		r4
s4
	movlw	0x05
	cpfseq	bdm_register,BANKED
	bra		s5
	bra		r5
s5
	movlw	0x06
	cpfseq	bdm_register,BANKED
	bra		s6
	bra		r6
s6
	movlw	0x07
	cpfseq	bdm_register,BANKED
	bra		s7
	bra		r7
s7
	movlw	0x08
	cpfseq	bdm_register,BANKED
	bra		s8
	bra		r8
s8
	movlw	0x09
	cpfseq	bdm_register,BANKED
	bra		s9
	bra		r9
s9
	movlw	0x0A
	cpfseq	bdm_register,BANKED
	bra		s10
	bra		r10
s10
	bra		err


disp_end
	rcall	bdm_receive
bdm_end
	bsf		DEBUG,BTRIS7
	bsf		DEBUG,BTRIS6
	bcf		DEBUG, SHDW
	movff	TBLPTRH_T,TBLPTRH
	movff	TBLPTRL_T,TBLPTRL
	MOVFF 	FS0L_T, FSR0L 
	MOVFF 	FS0H_T, FSR0H 
	MOVFF 	PCLU_T, PCLATU 
	MOVFF 	PCLH_T, PCLATH 
	MOVF 	W_TEMP, W
	MOVFF 	STAT_T, STATUS 
	movff 	BSR_TEMP, BSR
	tret
;	return


r1
	movf	STKPTR,W
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r2
;	bcf		DEBUG, SHDW
	movf	POSTINC0,W
;	bsf		DEBUG, SHDW
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r3
	movf	TOSH,W
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	movf	TOSL,W
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r4
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	FSR0H
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	FSR0L
;	bcf		DEBUG, SHDW
	movf	INDF0,W
;	bsf		DEBUG, SHDW
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r5
	TBLRD*+
	movf	TABLAT,W
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r6
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	TBLPTRH
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	TBLPTRL
	TBLRD*
	movf	TABLAT,W
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r7
	movlw	0xEE
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bsf		DEBUG,SSTEP
	bra		bdm_disp
r8
	movlw	0xAA
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r9
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	BIGBUG
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	GLOBUG
	movlw	0x33
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp
r10
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	FSR0H
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	FSR0L
	rcall	bdm_receive
	movf	bdm_register,W,BANKED
	movwf	INDF0
	movlw	0x33
	movwf	bdm_register,BANKED
	rcall	bdm_transmit
	bra		bdm_disp


err
	bra		disp_end

bdm_transmit
	movlw	0x08
	movwf	bdm_counter,BANKED
bdm_transmit_loop

t_wait_for_high
	movff 	DEBUG, WREG
	btfss 	WREG, BRB6
	bra		t_wait_for_high
	bcf		DEBUG,BTRIS7
	rrcf	bdm_register,BANKED
	btfss	STATUS,C
	bcf		DEBUG, BRB7
	btfsc	STATUS,C
	bsf		DEBUG, BRB7
t_wait_for_low
	movff 	DEBUG, WREG
	btfsc 	WREG, BRB6
	bra		t_wait_for_low
	decfsz	bdm_counter, BANKED
	bra		bdm_transmit_loop
	return

bdm_receive
	movlw	0x08
	movwf	bdm_counter,BANKED
	clrf	bdm_register,BANKED
bdm_receive_loop
wait_for_high
	movff 	DEBUG, WREG
	btfss 	WREG, BRB6
	bra		wait_for_high
	bsf		DEBUG,BTRIS7
;	nop
;	nop
;	nop
wait_for_low
	movff 	DEBUG, WREG
	btfsc 	WREG, BRB6
	bra		wait_for_low
;	nop
;	nop
	bcf		STATUS,C
	rrncf	bdm_register,BANKED
	movff 	DEBUG, WREG
	btfsc	WREG,BRB7
	bsf		bdm_register,7,BANKED
	decfsz	bdm_counter, BANKED
	bra		bdm_receive_loop
	return

	end